From b325d524c91be5860154516bb8b4ea2801e89552 Mon Sep 17 00:00:00 2001
From: David Christensen <david.christensen@crunchydata.com>
Date: Thu, 1 Jun 2023 11:34:14 -0400
Subject: [PATCH v1] Introduce initdb-selectable block sizes

Whereas we had traditionally used BLCKSZ to indicate the compile-time selected
block size, this commit adjusted things so the cluster block size can be
selected at initdb time.

In order to code for this, we introduce a few new defines:

- CLUSTER_BLOCK_SIZE is the blocksize for this cluster itself.  This is not
valid until BlockSizeInit() has been called in the given backend, which we do as
early as possible by parsing the ControlFile and using the blcksz field.

- MIN_BLOCK_SIZE and MAX_BLOCK_SIZE are the limits for the selectable block
size. It is required that CLUSTER_BLOCK_SIZE is a power of 2 between these two
constants.

- DEFAULT_BLOCK_SIZE is the moral equivalent of BLCKSZ; it is the built-in
default value.  This is used in a few places that just needed a buffer of an
arbitrary size, but the dynamic value CLUSTER_BLOCK_SIZE should almost always be
used instead.

- CLUSTER_RELSEG_SIZE is used instead of RELSEG_SIZE, since internally we are
storing the segment size in terms of number of blocks.  RELSEG_SIZE is still
kept, but is used in terms of the number of blocks of DEFAULT_BLOCK_SIZE;
CLUSTER_RELSEG_SIZE scales appropriately (and is the only thing used internally)
to keep the same target total segment size regardless of block size.

This patch uses a precalculated table to store the block size itself, as well as
additional derived values that have traditionally been compile-time
constants (example: MaxHeapTuplesPerPage).  The traditional macro names are kept
so code that doesn't care about it should not need to change, however the
definition of these has changed (see the CalcXXX() routines in blocksize.h for
details).

A new function, BlockSizeInit() populates the appropriate values based on the
target block size.  This should be called as early as possible in any code that
utilizes block sizes.  This patch adds this in the appropriate place on the
handful of src/bin/ programs that used BLCKSZ, so this caveat mainly impacts new
code.

Code which had previously used BLCKZ should likely be able to get away with
changing these instances to CLUSTER_BLOCK_SIZE, unless you're using a structure
allocated on the stack.  In these cases, the compiler will complain about
dynamic structure.  The solution is to utilize an expression with MAX_BLOCK_SIZE
instead of BLCKSZ, ensuring enough stack space is allocated for the maximum
size. This also does require using CLUSTER_BLOCK_SIZE or an expression based on
it when actually using this structure, so in practice more stack space may be
allocated then used in principal; as long as there is plenty of stack this
should have no specific impacts on code.

Initial (basic) performance testing shows only minor changes with the pgbench -S
benchmark, though this is obviously an area that will need considerable
testing/verification across multiple workloads.
---
 configure                                   |  14 +-
 configure.ac                                |  25 +--
 contrib/amcheck/verify_heapam.c             |  14 +-
 contrib/amcheck/verify_nbtree.c             |   6 +-
 contrib/bloom/blinsert.c                    |   4 +-
 contrib/bloom/bloom.h                       |  23 +-
 contrib/bloom/blutils.c                     |   6 +-
 contrib/bloom/blvacuum.c                    |   2 +-
 contrib/file_fdw/file_fdw.c                 |   6 +-
 contrib/pageinspect/btreefuncs.c            |   6 +-
 contrib/pageinspect/expected/checksum.out   |   2 +-
 contrib/pageinspect/expected/checksum_1.out |   2 +-
 contrib/pageinspect/rawpage.c               |  12 +-
 contrib/pageinspect/sql/checksum.sql        |   2 +-
 contrib/pg_surgery/heap_surgery.c           |   2 +-
 contrib/pg_walinspect/pg_walinspect.c       |   6 +-
 contrib/pgstattuple/pgstatapprox.c          |   6 +-
 contrib/pgstattuple/pgstatindex.c           |   4 +-
 contrib/pgstattuple/pgstattuple.c           |  10 +-
 contrib/postgres_fdw/deparse.c              |   2 +-
 contrib/postgres_fdw/postgres_fdw.c         |   2 +-
 doc/src/sgml/catalogs.sgml                  |   4 +-
 doc/src/sgml/config.sgml                    |  39 ++--
 doc/src/sgml/limits.sgml                    |   2 +-
 doc/src/sgml/monitoring.sgml                |   4 +-
 doc/src/sgml/pgfreespacemap.sgml            |   3 +-
 doc/src/sgml/ref/initdb.sgml                |  16 ++
 doc/src/sgml/ref/pg_resetwal.sgml           |  19 ++
 meson.build                                 |  11 +-
 src/backend/access/brin/brin_bloom.c        |   2 +-
 src/backend/access/brin/brin_pageops.c      |   4 +-
 src/backend/access/common/bufmask.c         |   4 +-
 src/backend/access/common/reloptions.c      |  33 ++-
 src/backend/access/common/syncscan.c        |   2 +-
 src/backend/access/common/toast_internals.c |   2 +-
 src/backend/access/gin/ginbtree.c           |  12 +-
 src/backend/access/gin/gindatapage.c        |  18 +-
 src/backend/access/gin/ginfast.c            |   4 +-
 src/backend/access/gin/ginget.c             |   6 +-
 src/backend/access/gin/ginvacuum.c          |   2 +-
 src/backend/access/gin/ginxlog.c            |   4 +-
 src/backend/access/gist/gist.c              |   2 +-
 src/backend/access/gist/gistbuild.c         |  16 +-
 src/backend/access/gist/gistbuildbuffers.c  |  10 +-
 src/backend/access/gist/gistutil.c          |   2 +-
 src/backend/access/gist/gistvacuum.c        |   6 +-
 src/backend/access/hash/hash.c              |   4 +-
 src/backend/access/hash/hashinsert.c        |   2 +-
 src/backend/access/hash/hashovfl.c          |   8 +-
 src/backend/access/hash/hashpage.c          |   6 +-
 src/backend/access/heap/README.HOT          |   2 +-
 src/backend/access/heap/heapam.c            |  26 +--
 src/backend/access/heap/heapam_handler.c    |   8 +-
 src/backend/access/heap/heaptoast.c         |   2 +-
 src/backend/access/heap/hio.c               |   2 +-
 src/backend/access/heap/pruneheap.c         |  14 +-
 src/backend/access/heap/rewriteheap.c       |   6 +-
 src/backend/access/heap/vacuumlazy.c        |  18 +-
 src/backend/access/heap/visibilitymap.c     |   8 +-
 src/backend/access/nbtree/nbtdedup.c        |   8 +-
 src/backend/access/nbtree/nbtinsert.c       |   2 +-
 src/backend/access/nbtree/nbtpage.c         |  22 +-
 src/backend/access/nbtree/nbtree.c          |  10 +-
 src/backend/access/nbtree/nbtsort.c         |  12 +-
 src/backend/access/nbtree/nbtxlog.c         |   4 +-
 src/backend/access/rmgrdesc/xlogdesc.c      |   2 +-
 src/backend/access/spgist/spgdoinsert.c     |   6 +-
 src/backend/access/spgist/spginsert.c       |   2 +-
 src/backend/access/spgist/spgscan.c         |   4 +-
 src/backend/access/spgist/spgtextproc.c     |  10 +-
 src/backend/access/spgist/spgutils.c        |   4 +-
 src/backend/access/spgist/spgvacuum.c       |  22 +-
 src/backend/access/table/tableam.c          |   2 +-
 src/backend/access/transam/README           |   2 +-
 src/backend/access/transam/clog.c           |   6 +-
 src/backend/access/transam/commit_ts.c      |   6 +-
 src/backend/access/transam/generic_xlog.c   |  18 +-
 src/backend/access/transam/multixact.c      |  12 +-
 src/backend/access/transam/slru.c           |  22 +-
 src/backend/access/transam/subtrans.c       |   4 +-
 src/backend/access/transam/timeline.c       |   2 +-
 src/backend/access/transam/varsup.c         |   2 +-
 src/backend/access/transam/xlog.c           | 132 ++++++++++--
 src/backend/access/transam/xloginsert.c     |  24 +--
 src/backend/access/transam/xlogprefetcher.c |   2 +-
 src/backend/access/transam/xlogreader.c     |  28 +--
 src/backend/access/transam/xlogrecovery.c   |  10 +-
 src/backend/backup/basebackup.c             |  41 ++--
 src/backend/backup/basebackup_lz4.c         |   6 +-
 src/backend/backup/basebackup_zstd.c        |   6 +-
 src/backend/bootstrap/bootstrap.c           |  14 +-
 src/backend/catalog/storage.c               |   2 +-
 src/backend/commands/analyze.c              |   4 +-
 src/backend/commands/async.c                |   6 +-
 src/backend/commands/vacuumparallel.c       |   2 +-
 src/backend/executor/nodeAgg.c              |  16 +-
 src/backend/nodes/tidbitmap.c               |   6 +-
 src/backend/optimizer/path/costsize.c       |  12 +-
 src/backend/optimizer/util/plancat.c        |   2 +-
 src/backend/po/de.po                        |   8 +-
 src/backend/po/es.po                        |   6 +-
 src/backend/po/fr.po                        |   6 +-
 src/backend/po/id.po                        |   4 +-
 src/backend/po/it.po                        |   4 +-
 src/backend/po/ja.po                        |   8 +-
 src/backend/po/ko.po                        |   6 +-
 src/backend/po/pl.po                        |   4 +-
 src/backend/po/pt_BR.po                     |   2 +-
 src/backend/po/ru.po                        |   8 +-
 src/backend/po/sv.po                        |   4 +-
 src/backend/po/tr.po                        |   4 +-
 src/backend/po/uk.po                        |   4 +-
 src/backend/po/zh_CN.po                     |   4 +-
 src/backend/replication/logical/worker.c    |   2 +-
 src/backend/storage/buffer/buf_init.c       |   4 +-
 src/backend/storage/buffer/bufmgr.c         |  22 +-
 src/backend/storage/buffer/freelist.c       |   2 +-
 src/backend/storage/buffer/localbuf.c       |   8 +-
 src/backend/storage/file/buffile.c          |  14 +-
 src/backend/storage/file/copydir.c          |   2 +-
 src/backend/storage/file/fd.c               |   4 +-
 src/backend/storage/freespace/README        |   8 +-
 src/backend/storage/freespace/freespace.c   |  29 ++-
 src/backend/storage/freespace/indexfsm.c    |   6 +-
 src/backend/storage/large_object/inv_api.c  |   4 +-
 src/backend/storage/lmgr/predicate.c        |   2 +-
 src/backend/storage/page/bufpage.c          |  34 +--
 src/backend/storage/smgr/README             |  52 +++++
 src/backend/storage/smgr/md.c               | 126 +++++------
 src/backend/utils/adt/pgstatfuncs.c         |   4 +-
 src/backend/utils/adt/selfuncs.c            |   2 +-
 src/backend/utils/init/miscinit.c           |   6 +-
 src/backend/utils/misc/guc.c                |  27 ++-
 src/backend/utils/misc/guc_tables.c         |  39 +++-
 src/backend/utils/sort/logtape.c            |  48 ++---
 src/backend/utils/sort/sharedtuplestore.c   |  12 +-
 src/backend/utils/sort/tuplesort.c          |   6 +-
 src/bin/initdb/initdb.c                     |  60 ++++--
 src/bin/initdb/meson.build                  |   1 +
 src/bin/initdb/t/002_blocksize.pl           |  24 +++
 src/bin/pg_basebackup/pg_basebackup.c       |   7 +
 src/bin/pg_basebackup/pg_receivewal.c       |   4 +
 src/bin/pg_basebackup/streamutil.c          |  59 ++++++
 src/bin/pg_basebackup/streamutil.h          |   3 +
 src/bin/pg_checksums/pg_checksums.c         |  34 ++-
 src/bin/pg_resetwal/pg_resetwal.c           |  54 ++++-
 src/bin/pg_resetwal/t/002_corrupted.pl      |   4 +-
 src/bin/pg_rewind/filemap.c                 |   5 +-
 src/bin/pg_rewind/pg_rewind.c               |  12 +-
 src/bin/pg_upgrade/file.c                   |  17 +-
 src/bin/pg_upgrade/meson.build              |   2 +
 src/bin/pg_upgrade/pg_upgrade.c             |   3 +
 src/bin/pg_upgrade/pg_upgrade.h             |   2 +-
 src/bin/pg_waldump/pg_waldump.c             |  36 +++-
 src/bin/pg_waldump/t/002_save_fullpage.pl   |   1 +
 src/common/Makefile                         |   1 +
 src/common/blocksize.c                      |  56 +++++
 src/common/file_utils.c                     |   6 +-
 src/common/meson.build                      |   1 +
 src/include/access/brin_page.h              |   2 +-
 src/include/access/ginblock.h               |   6 +-
 src/include/access/gist.h                   |   2 +-
 src/include/access/gist_private.h           |   6 +-
 src/include/access/hash.h                   |   8 +-
 src/include/access/heapam.h                 |   2 +-
 src/include/access/heaptoast.h              |  18 +-
 src/include/access/htup_details.h           |  16 +-
 src/include/access/itup.h                   |   5 +-
 src/include/access/nbtree.h                 | 211 +------------------
 src/include/access/nbtree_int.h             | 220 ++++++++++++++++++++
 src/include/access/slru.h                   |   2 +-
 src/include/access/spgist_private.h         |  14 +-
 src/include/access/xlog_internal.h          |   1 +
 src/include/access/xlogrecord.h             |   6 +-
 src/include/backup/basebackup_sink.h        |   4 +-
 src/include/c.h                             |   6 +-
 src/include/common/blocksize.h              |  91 ++++++++
 src/include/pg_config.h.in                  |  12 +-
 src/include/pg_config_manual.h              |  10 +-
 src/include/postgres.h                      |   1 +
 src/include/storage/bufmgr.h                |   4 +-
 src/include/storage/bufpage.h               |  20 +-
 src/include/storage/checksum.h              |   2 +-
 src/include/storage/checksum_impl.h         |  13 +-
 src/include/storage/freespace.h             |   1 +
 src/include/storage/fsm_internals.h         |   4 +-
 src/include/storage/large_object.h          |   6 +-
 src/include/storage/off.h                   |   4 +-
 src/include/utils/guc_tables.h              |   1 +
 src/include/utils/rel.h                     |   4 +-
 src/test/modules/test_slru/test_slru.c      |   2 +-
 src/test/regress/expected/btree_index.out   |   4 +-
 src/test/regress/expected/largeobject.out   |   2 +-
 src/test/regress/expected/largeobject_1.out |   2 +-
 src/test/regress/sql/btree_index.sql        |   4 +-
 src/test/regress/sql/largeobject.sql        |   2 +-
 src/tools/msvc/Mkvcbuild.pm                 |   2 +-
 src/tools/msvc/Solution.pm                  |   2 +-
 src/tools/pgindent/typedefs.list            |   1 -
 199 files changed, 1666 insertions(+), 970 deletions(-)
 create mode 100644 src/bin/initdb/t/002_blocksize.pl
 create mode 100644 src/common/blocksize.c
 create mode 100644 src/include/access/nbtree_int.h
 create mode 100644 src/include/common/blocksize.h

diff --git a/configure.ac b/configure.ac
index 0e8158a5e6..aa796ab9dc 100644
--- a/configure.ac
+++ b/configure.ac
@@ -258,28 +258,29 @@ PGAC_ARG_REQ(with, blocksize, [BLOCKSIZE], [set table block size in kB [8]],
              [blocksize=$withval],
              [blocksize=8])
 case ${blocksize} in
-  1) BLCKSZ=1024;;
-  2) BLCKSZ=2048;;
-  4) BLCKSZ=4096;;
-  8) BLCKSZ=8192;;
- 16) BLCKSZ=16384;;
- 32) BLCKSZ=32768;;
+  1) DEFAULT_BLOCK_SIZE=1024;;
+  2) DEFAULT_BLOCK_SIZE=2048;;
+  4) DEFAULT_BLOCK_SIZE=4096;;
+  8) DEFAULT_BLOCK_SIZE=8192;;
+ 16) DEFAULT_BLOCK_SIZE=16384;;
+ 32) DEFAULT_BLOCK_SIZE=32768;;
   *) AC_MSG_ERROR([Invalid block size. Allowed values are 1,2,4,8,16,32.])
 esac
 AC_MSG_RESULT([${blocksize}kB])
 
-AC_DEFINE_UNQUOTED([BLCKSZ], ${BLCKSZ}, [
+AC_DEFINE_UNQUOTED([DEFAULT_BLOCK_SIZE], ${DEFAULT_BLOCK_SIZE}, [
  Size of a disk block --- this also limits the size of a tuple.  You
  can set it bigger if you need bigger tuples (although TOAST should
  reduce the need to have large tuples, since fields can be spread
  across multiple tuples).
 
- BLCKSZ must be a power of 2.  The maximum possible value of BLCKSZ
+ DEFAULT_BLOCK_SIZE must be a power of 2.  The maximum possible value of DEFAULT_BLOCK_SIZE
  is currently 2^15 (32768).  This is determined by the 15-bit widths
  of the lp_off and lp_len fields in ItemIdData (see
  include/storage/itemid.h).
 
- Changing BLCKSZ requires an initdb.
+ Changing DEFAULT_BLOCK_SIZE requires an initdb, however an individual cluster
+ can have its block size set.
 ])
 
 #
@@ -313,10 +314,10 @@ fi
 
 AC_DEFINE_UNQUOTED([RELSEG_SIZE], ${RELSEG_SIZE}, [
  RELSEG_SIZE is the maximum number of blocks allowed in one disk file.
- Thus, the maximum size of a single file is RELSEG_SIZE * BLCKSZ;
+ Thus, the maximum size of a single file is RELSEG_SIZE * CLUSTER_BLOCK_SIZE;
  relations bigger than that are divided into multiple files.
 
- RELSEG_SIZE * BLCKSZ must be less than your OS' limit on file size.
+ RELSEG_SIZE * CLUSTER_BLOCK_SIZE must be less than your OS' limit on file size.
  This is often 2 GB or 4GB in a 32-bit operating system, unless you
  have large file support enabled.  By default, we make the limit 1 GB
  to avoid any possible integer-overflow problems within the OS.
@@ -350,7 +351,7 @@ esac
 AC_MSG_RESULT([${wal_blocksize}kB])
 
 AC_DEFINE_UNQUOTED([XLOG_BLCKSZ], ${XLOG_BLCKSZ}, [
- Size of a WAL file block.  This need have no particular relation to BLCKSZ.
+ Size of a WAL file block.  This need have no particular relation to CLUSTER_BLOCK_SIZE.
  XLOG_BLCKSZ must be a power of 2, and if your system supports O_DIRECT I/O,
  XLOG_BLCKSZ must be a multiple of the alignment requirement for direct-I/O
  buffers, else direct I/O may fail.
diff --git a/contrib/amcheck/verify_heapam.c b/contrib/amcheck/verify_heapam.c
index 97f3253522..b4453f1797 100644
--- a/contrib/amcheck/verify_heapam.c
+++ b/contrib/amcheck/verify_heapam.c
@@ -403,11 +403,11 @@ verify_heapam(PG_FUNCTION_ARGS)
 	for (ctx.blkno = first_block; ctx.blkno <= last_block; ctx.blkno++)
 	{
 		OffsetNumber maxoff;
-		OffsetNumber predecessor[MaxOffsetNumber];
-		OffsetNumber successor[MaxOffsetNumber];
-		bool		lp_valid[MaxOffsetNumber];
-		bool		xmin_commit_status_ok[MaxOffsetNumber];
-		XidCommitStatus xmin_commit_status[MaxOffsetNumber];
+		OffsetNumber predecessor[MaxOffsetNumberLimit];
+		OffsetNumber successor[MaxOffsetNumberLimit];
+		bool		lp_valid[MaxOffsetNumberLimit];
+		bool		xmin_commit_status_ok[MaxOffsetNumberLimit];
+		XidCommitStatus xmin_commit_status[MaxOffsetNumberLimit];
 
 		CHECK_FOR_INTERRUPTS();
 
@@ -540,13 +540,13 @@ verify_heapam(PG_FUNCTION_ARGS)
 										   (unsigned) MAXALIGN(SizeofHeapTupleHeader)));
 				continue;
 			}
-			if (ctx.lp_off + ctx.lp_len > BLCKSZ)
+			if (ctx.lp_off + ctx.lp_len > CLUSTER_BLOCK_SIZE)
 			{
 				report_corruption(&ctx,
 								  psprintf("line pointer to page offset %u with length %u ends beyond maximum page offset %u",
 										   ctx.lp_off,
 										   ctx.lp_len,
-										   (unsigned) BLCKSZ));
+										   (unsigned) CLUSTER_BLOCK_SIZE));
 				continue;
 			}
 
diff --git a/contrib/amcheck/verify_nbtree.c b/contrib/amcheck/verify_nbtree.c
index 94a9759322..62276d108e 100644
--- a/contrib/amcheck/verify_nbtree.c
+++ b/contrib/amcheck/verify_nbtree.c
@@ -2962,7 +2962,7 @@ palloc_btree_page(BtreeCheckState *state, BlockNumber blocknum)
 	BTPageOpaque opaque;
 	OffsetNumber maxoffset;
 
-	page = palloc(BLCKSZ);
+	page = palloc(CLUSTER_BLOCK_SIZE);
 
 	/*
 	 * We copy the page into local storage to avoid holding pin on the buffer
@@ -2979,7 +2979,7 @@ palloc_btree_page(BtreeCheckState *state, BlockNumber blocknum)
 	_bt_checkpage(state->rel, buffer);
 
 	/* Only use copy of page in palloc()'d memory */
-	memcpy(page, BufferGetPage(buffer), BLCKSZ);
+	memcpy(page, BufferGetPage(buffer), CLUSTER_BLOCK_SIZE);
 	UnlockReleaseBuffer(buffer);
 
 	opaque = BTPageGetOpaque(page);
@@ -3163,7 +3163,7 @@ PageGetItemIdCareful(BtreeCheckState *state, BlockNumber block, Page page,
 	ItemId		itemid = PageGetItemId(page, offset);
 
 	if (ItemIdGetOffset(itemid) + ItemIdGetLength(itemid) >
-		BLCKSZ - MAXALIGN(sizeof(BTPageOpaqueData)))
+		CLUSTER_BLOCK_SIZE - MAXALIGN(sizeof(BTPageOpaqueData)))
 		ereport(ERROR,
 				(errcode(ERRCODE_INDEX_CORRUPTED),
 				 errmsg("line pointer points past end of tuple space in index \"%s\"",
diff --git a/contrib/bloom/blinsert.c b/contrib/bloom/blinsert.c
index b42b9e6c41..3c36c985f3 100644
--- a/contrib/bloom/blinsert.c
+++ b/contrib/bloom/blinsert.c
@@ -52,7 +52,7 @@ flushCachedPage(Relation index, BloomBuildState *buildstate)
 
 	state = GenericXLogStart(index);
 	page = GenericXLogRegisterBuffer(state, buffer, GENERIC_XLOG_FULL_IMAGE);
-	memcpy(page, buildstate->data.data, BLCKSZ);
+	memcpy(page, buildstate->data.data, CLUSTER_BLOCK_SIZE);
 	GenericXLogFinish(state);
 	UnlockReleaseBuffer(buffer);
 }
@@ -166,7 +166,7 @@ blbuildempty(Relation index)
 	Page		metapage;
 
 	/* Construct metapage. */
-	metapage = (Page) palloc_aligned(BLCKSZ, PG_IO_ALIGN_SIZE, 0);
+	metapage = (Page) palloc_aligned(CLUSTER_BLOCK_SIZE, PG_IO_ALIGN_SIZE, 0);
 	BloomFillMetapage(index, metapage);
 
 	/*
diff --git a/contrib/bloom/bloom.h b/contrib/bloom/bloom.h
index efdf9415d1..683ecb8a77 100644
--- a/contrib/bloom/bloom.h
+++ b/contrib/bloom/bloom.h
@@ -106,16 +106,9 @@ typedef struct BloomOptions
 											 * index key */
 } BloomOptions;
 
-/*
- * FreeBlockNumberArray - array of block numbers sized so that metadata fill
- * all space in metapage.
- */
-typedef BlockNumber FreeBlockNumberArray[
-										 MAXALIGN_DOWN(
-													   BLCKSZ - SizeOfPageHeaderData - MAXALIGN(sizeof(BloomPageOpaqueData))
-													   - MAXALIGN(sizeof(uint16) * 2 + sizeof(uint32) + sizeof(BloomOptions))
-													   ) / sizeof(BlockNumber)
-];
+#define FREE_BLOCK_NUMBER_ELEMS CalcFreeBlockNumberElems(CLUSTER_BLOCK_SIZE)
+
+
 
 /* Metadata of bloom index */
 typedef struct BloomMetaPageData
@@ -124,14 +117,18 @@ typedef struct BloomMetaPageData
 	uint16		nStart;
 	uint16		nEnd;
 	BloomOptions opts;
-	FreeBlockNumberArray notFullPage;
+	BlockNumber notFullPage[FLEXIBLE_ARRAY_MEMBER];
 } BloomMetaPageData;
 
+#define SizeOfBloomMetaPageData (offsetof(BloomMetaPageData,notFullPage) + sizeof(BlockNumber) * BloomMetaBlockN)
+
 /* Magic number to distinguish bloom pages among anothers */
 #define BLOOM_MAGICK_NUMBER (0xDBAC0DED)
 
 /* Number of blocks numbers fit in BloomMetaPageData */
-#define BloomMetaBlockN		(sizeof(FreeBlockNumberArray) / sizeof(BlockNumber))
+#define BloomMetaBlockN		(MAXALIGN_DOWN(CLUSTER_BLOCK_SIZE - SizeOfPageHeaderData - MAXALIGN(sizeof(BloomPageOpaqueData)) \
+													   - MAXALIGN(sizeof(uint16) * 2 + sizeof(uint32) + sizeof(BloomOptions)) \
+								  ) / sizeof(BlockNumber))
 
 #define BloomPageGetMeta(page)	((BloomMetaPageData *) PageGetContents(page))
 
@@ -150,7 +147,7 @@ typedef struct BloomState
 } BloomState;
 
 #define BloomPageGetFreeSpace(state, page) \
-	(BLCKSZ - MAXALIGN(SizeOfPageHeaderData) \
+	(CLUSTER_BLOCK_SIZE - MAXALIGN(SizeOfPageHeaderData) \
 		- BloomPageGetMaxOffset(page) * (state)->sizeOfBloomTuple \
 		- MAXALIGN(sizeof(BloomPageOpaqueData)))
 
diff --git a/contrib/bloom/blutils.c b/contrib/bloom/blutils.c
index d935ed8fbd..c8abdc86f6 100644
--- a/contrib/bloom/blutils.c
+++ b/contrib/bloom/blutils.c
@@ -400,7 +400,7 @@ BloomInitPage(Page page, uint16 flags)
 {
 	BloomPageOpaque opaque;
 
-	PageInit(page, BLCKSZ, sizeof(BloomPageOpaqueData));
+	PageInit(page, CLUSTER_BLOCK_SIZE, sizeof(BloomPageOpaqueData));
 
 	opaque = BloomPageGetOpaque(page);
 	opaque->flags = flags;
@@ -430,10 +430,10 @@ BloomFillMetapage(Relation index, Page metaPage)
 	 */
 	BloomInitPage(metaPage, BLOOM_META);
 	metadata = BloomPageGetMeta(metaPage);
-	memset(metadata, 0, sizeof(BloomMetaPageData));
+	memset(metadata, 0, SizeOfBloomMetaPageData);
 	metadata->magickNumber = BLOOM_MAGICK_NUMBER;
 	metadata->opts = *opts;
-	((PageHeader) metaPage)->pd_lower += sizeof(BloomMetaPageData);
+	((PageHeader) metaPage)->pd_lower += SizeOfBloomMetaPageData;
 
 	/* If this fails, probably FreeBlockNumberArray size calc is wrong: */
 	Assert(((PageHeader) metaPage)->pd_lower <= ((PageHeader) metaPage)->pd_upper);
diff --git a/contrib/bloom/blvacuum.c b/contrib/bloom/blvacuum.c
index 2340d49e00..373227af98 100644
--- a/contrib/bloom/blvacuum.c
+++ b/contrib/bloom/blvacuum.c
@@ -37,7 +37,7 @@ blbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
 	Relation	index = info->index;
 	BlockNumber blkno,
 				npages;
-	FreeBlockNumberArray notFullPage;
+	BlockNumber notFullPage[CalcFreeBlockNumberElems(MAX_BLOCK_SIZE)];
 	int			countPage = 0;
 	BloomState	state;
 	Buffer		buffer;
diff --git a/contrib/file_fdw/file_fdw.c b/contrib/file_fdw/file_fdw.c
index 9e330b9934..e8e159c81b 100644
--- a/contrib/file_fdw/file_fdw.c
+++ b/contrib/file_fdw/file_fdw.c
@@ -839,7 +839,7 @@ fileAnalyzeForeignTable(Relation relation,
 	 * Convert size to pages.  Must return at least 1 so that we can tell
 	 * later on that pg_class.relpages is not default.
 	 */
-	*totalpages = (stat_buf.st_size + (BLCKSZ - 1)) / BLCKSZ;
+	*totalpages = (stat_buf.st_size + (CLUSTER_BLOCK_SIZE - 1)) / CLUSTER_BLOCK_SIZE;
 	if (*totalpages < 1)
 		*totalpages = 1;
 
@@ -1009,12 +1009,12 @@ estimate_size(PlannerInfo *root, RelOptInfo *baserel,
 	 * back to the default if using a program as the input.
 	 */
 	if (fdw_private->is_program || stat(fdw_private->filename, &stat_buf) < 0)
-		stat_buf.st_size = 10 * BLCKSZ;
+		stat_buf.st_size = 10 * CLUSTER_BLOCK_SIZE;
 
 	/*
 	 * Convert size to pages for use in I/O cost estimate later.
 	 */
-	pages = (stat_buf.st_size + (BLCKSZ - 1)) / BLCKSZ;
+	pages = (stat_buf.st_size + (CLUSTER_BLOCK_SIZE - 1)) / CLUSTER_BLOCK_SIZE;
 	if (pages < 1)
 		pages = 1;
 	fdw_private->pages = pages;
diff --git a/contrib/pageinspect/btreefuncs.c b/contrib/pageinspect/btreefuncs.c
index 9cdc8e182b..dd6115cbc7 100644
--- a/contrib/pageinspect/btreefuncs.c
+++ b/contrib/pageinspect/btreefuncs.c
@@ -116,7 +116,7 @@ GetBTPageStatistics(BlockNumber blkno, Buffer buffer, BTPageStat *stat)
 
 	stat->blkno = blkno;
 
-	stat->max_avail = BLCKSZ - (BLCKSZ - phdr->pd_special + SizeOfPageHeaderData);
+	stat->max_avail = CLUSTER_BLOCK_SIZE - (CLUSTER_BLOCK_SIZE - phdr->pd_special + SizeOfPageHeaderData);
 
 	stat->dead_items = stat->live_items = 0;
 
@@ -663,8 +663,8 @@ bt_page_items_internal(PG_FUNCTION_ARGS, enum pageinspect_version ext_version)
 
 		uargs = palloc(sizeof(ua_page_items));
 
-		uargs->page = palloc(BLCKSZ);
-		memcpy(uargs->page, BufferGetPage(buffer), BLCKSZ);
+		uargs->page = palloc(CLUSTER_BLOCK_SIZE);
+		memcpy(uargs->page, BufferGetPage(buffer), CLUSTER_BLOCK_SIZE);
 
 		UnlockReleaseBuffer(buffer);
 		relation_close(rel, AccessShareLock);
diff --git a/contrib/pageinspect/rawpage.c b/contrib/pageinspect/rawpage.c
index b25a63cbd6..cb8bd8de91 100644
--- a/contrib/pageinspect/rawpage.c
+++ b/contrib/pageinspect/rawpage.c
@@ -179,8 +179,8 @@ get_raw_page_internal(text *relname, ForkNumber forknum, BlockNumber blkno)
 						blkno, RelationGetRelationName(rel))));
 
 	/* Initialize buffer to copy to */
-	raw_page = (bytea *) palloc(BLCKSZ + VARHDRSZ);
-	SET_VARSIZE(raw_page, BLCKSZ + VARHDRSZ);
+	raw_page = (bytea *) palloc(CLUSTER_BLOCK_SIZE + VARHDRSZ);
+	SET_VARSIZE(raw_page, CLUSTER_BLOCK_SIZE + VARHDRSZ);
 	raw_page_data = VARDATA(raw_page);
 
 	/* Take a verbatim copy of the page */
@@ -188,7 +188,7 @@ get_raw_page_internal(text *relname, ForkNumber forknum, BlockNumber blkno)
 	buf = ReadBufferExtended(rel, forknum, blkno, RBM_NORMAL, NULL);
 	LockBuffer(buf, BUFFER_LOCK_SHARE);
 
-	memcpy(raw_page_data, BufferGetPage(buf), BLCKSZ);
+	memcpy(raw_page_data, BufferGetPage(buf), CLUSTER_BLOCK_SIZE);
 
 	LockBuffer(buf, BUFFER_LOCK_UNLOCK);
 	ReleaseBuffer(buf);
@@ -219,12 +219,12 @@ get_page_from_raw(bytea *raw_page)
 
 	raw_page_size = VARSIZE_ANY_EXHDR(raw_page);
 
-	if (raw_page_size != BLCKSZ)
+	if (raw_page_size != CLUSTER_BLOCK_SIZE)
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
 				 errmsg("invalid page size"),
 				 errdetail("Expected %d bytes, got %d.",
-						   BLCKSZ, raw_page_size)));
+						   CLUSTER_BLOCK_SIZE, raw_page_size)));
 
 	page = palloc(raw_page_size);
 
@@ -357,7 +357,7 @@ page_checksum_internal(PG_FUNCTION_ARGS, enum pageinspect_version ext_version)
 	if (PageIsNew(page))
 		PG_RETURN_NULL();
 
-	PG_RETURN_INT16(pg_checksum_page((char *) page, blkno));
+	PG_RETURN_INT16(pg_checksum_page((char *) page, blkno, CLUSTER_BLOCK_SIZE));
 }
 
 Datum
diff --git a/contrib/pageinspect/sql/checksum.sql b/contrib/pageinspect/sql/checksum.sql
index b877db0611..98eb1c3b8c 100644
--- a/contrib/pageinspect/sql/checksum.sql
+++ b/contrib/pageinspect/sql/checksum.sql
@@ -6,7 +6,7 @@
 -- on the configured block size.  This test has several different expected
 -- results files to handle the following possibilities:
 --
---	BLCKSZ	end	file
+--	CLUSTER_BLOCK_SIZE	end	file
 --	8K	LE	checksum.out
 --	8K	BE	checksum_1.out
 --
diff --git a/contrib/pg_surgery/heap_surgery.c b/contrib/pg_surgery/heap_surgery.c
index 88a40ab7d3..58c4819675 100644
--- a/contrib/pg_surgery/heap_surgery.c
+++ b/contrib/pg_surgery/heap_surgery.c
@@ -89,7 +89,7 @@ heap_force_common(FunctionCallInfo fcinfo, HeapTupleForceOption heap_force_opt)
 	Relation	rel;
 	OffsetNumber curr_start_ptr,
 				next_start_ptr;
-	bool		include_this_tid[MaxHeapTuplesPerPage];
+	bool		include_this_tid[MaxHeapTuplesPerPageLimit];
 
 	if (RecoveryInProgress())
 		ereport(ERROR,
diff --git a/contrib/pg_walinspect/pg_walinspect.c b/contrib/pg_walinspect/pg_walinspect.c
index 796a74f322..3a5a852989 100644
--- a/contrib/pg_walinspect/pg_walinspect.c
+++ b/contrib/pg_walinspect/pg_walinspect.c
@@ -386,9 +386,9 @@ GetWALBlockInfo(FunctionCallInfo fcinfo, XLogReaderState *record,
 						(errcode(ERRCODE_INTERNAL_ERROR),
 						 errmsg_internal("%s", record->errormsg_buf)));
 
-			block_fpi_data = (bytea *) palloc(BLCKSZ + VARHDRSZ);
-			SET_VARSIZE(block_fpi_data, BLCKSZ + VARHDRSZ);
-			memcpy(VARDATA(block_fpi_data), page, BLCKSZ);
+			block_fpi_data = (bytea *) palloc(CLUSTER_BLOCK_SIZE + VARHDRSZ);
+			SET_VARSIZE(block_fpi_data, CLUSTER_BLOCK_SIZE + VARHDRSZ);
+			memcpy(VARDATA(block_fpi_data), page, CLUSTER_BLOCK_SIZE);
 			values[i++] = PointerGetDatum(block_fpi_data);
 		}
 		else
diff --git a/contrib/pgstattuple/pgstatapprox.c b/contrib/pgstattuple/pgstatapprox.c
index f601dc6121..d961e91f09 100644
--- a/contrib/pgstattuple/pgstatapprox.c
+++ b/contrib/pgstattuple/pgstatapprox.c
@@ -94,7 +94,7 @@ statapprox_heap(Relation rel, output_type *stat)
 		if (VM_ALL_VISIBLE(rel, blkno, &vmbuffer))
 		{
 			freespace = GetRecordedFreeSpace(rel, blkno);
-			stat->tuple_len += BLCKSZ - freespace;
+			stat->tuple_len += CLUSTER_BLOCK_SIZE - freespace;
 			stat->free_space += freespace;
 			continue;
 		}
@@ -113,7 +113,7 @@ statapprox_heap(Relation rel, output_type *stat)
 		if (!PageIsNew(page))
 			stat->free_space += PageGetHeapFreeSpace(page);
 		else
-			stat->free_space += BLCKSZ - SizeOfPageHeaderData;
+			stat->free_space += CLUSTER_BLOCK_SIZE - SizeOfPageHeaderData;
 
 		/* We may count the page as scanned even if it's new/empty */
 		scanned++;
@@ -182,7 +182,7 @@ statapprox_heap(Relation rel, output_type *stat)
 		UnlockReleaseBuffer(buf);
 	}
 
-	stat->table_len = (uint64) nblocks * BLCKSZ;
+	stat->table_len = (uint64) nblocks * CLUSTER_BLOCK_SIZE;
 
 	/*
 	 * We don't know how many tuples are in the pages we didn't scan, so
diff --git a/contrib/pgstattuple/pgstatindex.c b/contrib/pgstattuple/pgstatindex.c
index d69ac1c93d..a0367184b8 100644
--- a/contrib/pgstattuple/pgstatindex.c
+++ b/contrib/pgstattuple/pgstatindex.c
@@ -297,7 +297,7 @@ pgstatindex_impl(Relation rel, FunctionCallInfo fcinfo)
 		{
 			int			max_avail;
 
-			max_avail = BLCKSZ - (BLCKSZ - ((PageHeader) page)->pd_special + SizeOfPageHeaderData);
+			max_avail = CLUSTER_BLOCK_SIZE - (CLUSTER_BLOCK_SIZE - ((PageHeader) page)->pd_special + SizeOfPageHeaderData);
 			indexStat.max_avail += max_avail;
 			indexStat.free_space += PageGetFreeSpace(page);
 
@@ -342,7 +342,7 @@ pgstatindex_impl(Relation rel, FunctionCallInfo fcinfo)
 								indexStat.leaf_pages +
 								indexStat.internal_pages +
 								indexStat.deleted_pages +
-								indexStat.empty_pages) * BLCKSZ);
+								indexStat.empty_pages) * CLUSTER_BLOCK_SIZE);
 		values[j++] = psprintf("%u", indexStat.root_blkno);
 		values[j++] = psprintf(INT64_FORMAT, indexStat.internal_pages);
 		values[j++] = psprintf(INT64_FORMAT, indexStat.leaf_pages);
